unit ADS7843;

{
Copyright (C) 2016 - Ronald Daleske


some procedures in this unit have taken some ideas of the C sources of:

Rinky-Dink Electronics, Henning Karlsen
http://www.rinkydinkelectronics.com/library.php


Licence
=======

 LGPLv2.1 with static linking exception (See COPYING.modifiedLGPL.txt)

}


{$mode objfpc}{$H+}

interface

uses
  Threads,
  Platform,
  RGPIO;


const
  PORTRAIT  : Byte = 0;
  LANDSCAPE : Byte = 1;

  PREC_LOW     : Byte = 1;
  PREC_MEDIUM  : Byte = 2;
  PREC_HI      : Byte = 3;
  PREC_EXTREME : Byte = 5;


  PixSizeX : LongWord = 1378;    // * 100
  PixOffsX : LongWord = 411;
  PixSizeY : LongWord = 1101;    // * 100
  PixOffsY : LongWord = 378;


{
T_CLK = GPIO10 -> A
T_CS  = GPIO9  -> A
T_DIN = GPIO11 -> A
T_DOUT= GPIO6  -> E
T_IRQ = GPIO5  -> E
}


function ADS7843_dataAvailable : Boolean;
procedure ADS7843_Read;
function ADS7843_getX : Word;
function ADS7843_getY : Word;


var
  TP_X ,TP_Y : Word;
  prec, orient : Byte;



implementation







// T_CLK = GPIO10
procedure T_CLK_Clear;
begin
  GPIO10_Clear;
end;


// T_CLK = GPIO10
procedure T_CLK_Set;
begin
  GPIO10_Set;
end;



// T_CS  = GPIO9
procedure T_CS_active;
begin
  GPIO9_Clear;
end;


// T_CS  = GPIO9;
procedure T_CS_inactive;
begin
  GPIO9_Set;
end;




// T_DIN = GPIO11
procedure T_DIN_Clear;
begin
  GPIO11_Clear;
end;


// T_DIN = GPIO11
procedure T_DIN_Set;
begin
  GPIO11_Set;
end;




// T_DOUT= GPIO6
function T_DOUT_Read : Boolean;
begin
  Result:=GPIO6_Read;
end;


// T_IRQ = GPIO5
function T_IRQ_Read : Boolean;
begin
  Result:=GPIO5_Read;
end;




procedure Init_ADS7843;
begin

  prec:= PREC_EXTREME;
  orient:=LANDSCAPE;

  {
  T_CLK = GPIO10 -> A
  T_CS  = GPIO9  -> A
  T_DIN = GPIO11 -> A
  T_DOUT= GPIO6  -> E
  T_IRQ = GPIO5  -> E
  }

  GPIO_OUT_Init(GPIO10);
  GPIO_OUT_Init(GPIO9);
  GPIO_OUT_Init(GPIO11);
  GPIO_IN_Init(GPIO6);
  GPIO_IN_Init(GPIO5);

  T_CS_inactive;
  T_CLK_Set;
  T_DIN_Set;
  T_CLK_Set;

  // T_CLK_Clear;

end; { procedure Init_ADS7843 }






// Read one Word from Touch
function Touch_ReadData : Word;
var
  touch_data : Word;
  touch_couter : Byte;
begin

  touch_data:=0;

  for touch_couter:=0 to 11 do begin

    touch_data:=touch_data shl 1;

    T_CLK_Set;
    MicrosecondDelay(2);

    T_CLK_Clear;
    MicrosecondDelay(2);

    if T_DOUT_Read then
      INC(touch_data);

  end; { for ds_couter:=0 to 7 do }

  Result:=touch_data;

end; { function Touch_ReadData }






// Write one Byte to Touch
procedure Touch_WriteData(touch_data : Byte);
var
  touch_couter, touch_temp : Byte;
begin

  touch_temp:=touch_data;

  T_CLK_Clear;
  MicrosecondDelay(2);

  for touch_couter:=0 to 7 do begin

    if (touch_temp and %10000000) = 0 then
      T_DIN_Clear
    else
      T_DIN_Set;

    touch_temp:=touch_temp shl 1;

    T_CLK_Clear;
    MicrosecondDelay(2);
    T_CLK_Set;
    MicrosecondDelay(2);

  end; { for ds_couter:=0 to 7 do }

end; { procedure Touch_WriteData }








//
procedure ADS7843_Read;
var
  tx, ty : Word;
  touch_couter : Byte;
begin

  tx:=0; ty:=0;

  T_CS_active;
  MicrosecondDelay(2);

  for touch_couter:=1 to prec do begin

    Touch_WriteData($90);

    T_CLK_Set;
    MicrosecondDelay(2);
    T_CLK_Clear;

    ty:=ty+Touch_ReadData;


    Touch_WriteData($D0);

    T_CLK_Set;
    MicrosecondDelay(2);
    T_CLK_Clear;

    tx:=tx+Touch_ReadData;

  end; { for ds_couter:=0 to 7 do }

  T_CS_inactive;

  TP_X := tx div prec;
  TP_Y := ty div prec;

end; { procedure ADS7843_Read }





//
function ADS7843_dataAvailable : Boolean;
begin

  if T_IRQ_Read then
    Result:=false
  else
    Result:=true;

end; { function ADS7843_dataAvailable }




//
function ADS7843_getX : Word;
var
  getX_value : LongWord;
begin

  if (orient = PORTRAIT) then begin



  end
  else
  begin

    // getX_value:=(320*TP_Y) div 4096;
    getX_value:=(((320+42)*TP_Y) div 4096)-28;


  end; { if (orient = PORTRAIT) then }

  Result:=Word(getX_value);

end; { function ADS7843_getX }







//
function ADS7843_getY : Word;
var
  getY_value : LongWord;
begin

  if (orient = PORTRAIT) then begin



  end
  else
  begin

    // getX_value:=(240*TP_X) div 4096;
    getY_value:=(((240+30)*TP_X) div 4096)-15;


  end; { if (orient = PORTRAIT) then }

  Result:=Word(getY_value);

end; { function ADS7843_getY }







{==============================================================================}
{==============================================================================}

initialization
 Init_ADS7843

{==============================================================================}

finalization
 {Nothing}

{==============================================================================}
{==============================================================================}

end.


